;******************************************************************
;

;******************************************************************
;
;     PROGRAMA VIETOJ IVESTU SKAICIU PAKEICIAU JUOS ZODZIAIS ...
;     Pvz: vedus b23a turi atspausdinti bdutrysa
;
;******************************************************************

.model small                          ; programos apimtis maza

    buferioDydis EQU	250         ; buferi nusistatom su dydziu 250  (equ - equal)     

.stack 100h                           ; steko dydis 100h - 256 (baitais)

.data                                 ; toliau esantis turinys bus sudetas i duomenu segmenta
	
	; eiluts nuskaitymo buferis
	bufDydis db  buferioDydis		    ; kiek maksimaliai simboli galima nuskaityti
	nuskaite db  ?				        ; bus irasyta kiek nuskaite simboliu
	buferis	 db  buferioDydis dup (0)	; ia bus talpinami nuskaityti simboliai, is pradziu visi baitai bus uzpildomi 0
	
	; kiti duomenys
	rezultatas	                   db  'Gauta nauja eilute: $'
	ivedimas	                   db  'Iveskite eilute: $'
	klaidosPranesimas              db  'Neteisinga ivestis (Nieko nebuvo ivesta)...', 13, 10, '$'
	informacijosPranesimas         db  'Programa ivestus skaicius pakeicia zodziais...', 13, 10, '$'
	pabaigosPranesimas             db  'Programa baigta...', 13, 10, '$'
	enteris                        db  13, 10, '$'
	
	; skaiciai
	nulis              db  'nulis$'
	vienas             db  'vienas$'
	du                 db  'du$'
	trys               db  'trys$'
	keturi             db  'keturi$'
	penki              db  'penki$'
	sesi               db  'sesi$'
	septyni            db  'septyni$'
	astuoni            db  'astuoni$'
	devyni             db  'devyni$'
	
.code                                       ; toliau esantis turinys bus sudetas i kodo segmenta

pradzia:
     
	mov ax, @data                           ; perkelia data i registra ax, reikalinga kiekvienos programos pradioj (i ax ikeliama duomenu segmento pradzios adresas)
	mov ds, ax                              ; nustato ds rodyti i data segmenta, reikalinga kiekvienos programos pradioj (i dx ikeliama ax reiksme)
	
	mov dx, offset informacijosPranesimas 	; isvedamojo teksto adresas
    mov ah, 09h		      	                ; spausdinimo funckijos numeris
    int 21h			                        ; isveda pranesima
	
	; nuskaitom gauta eilute
	mov dx, offset ivedimas 	            ; isvedamojo teksto adresas
    mov ah, 09h		      	                ; spausdinimo funckijos numeris
    int 21h			                        ; isveda klausima
	
	mov dx, offset bufDydis                 ; nuskaitoma vesta eilute 
	mov ah, 0Ah                             ; 0Ah(sesioliktaine) - 10, ivedimui reikalinga. Nuskaitymo funckijos numeris                 
	int 21h                                 ; gauti eilute 
	
	mov	dx, offset enteris                  ; isvedamojo teksto adresas
	mov ah, 09h                             ; spausdinimo funckijos numeris
	int	21h			                       
	
toliau: 
    
	mov	cl, nuskaite	      ;  cl dedama kiek simboli buvo nuskaityta
	xor ch, ch                ; isvalomas ch, kad nebutu siuksliu
					          ; cl - kiek simboli liko perirti
	mov	bx, offset buferis	  ; i bx dedama tai kas buvo nuskaityta (cia offset naudojama, kai dirbama su ekranu)
					          ; bx - einamojo simbolio adresas
	
	jmp tikrinimas            ; einame tikrinti kas buvo ivesta

rezultatui:
    
    mov dx, offset rezultatas 	        ; isvedamojo teksto adresas
    mov ah, 09h		      	            ; spausdinimo funckijos numeris
    int 21h			                    ; isveda pranesima	
    
	jmp ciklas                          ; po isvedimo sokame i cikla 
	
tikrinimas:                             ; tikrinam ar buvo ivestas nors 1 simbolis

	cmp	cl, 0                           ; lyginima ar nuskaityti simboliu skaicius nera lygus 0
	jne rezultatui                      ; jei radom, kad yra ivestas nors 1 simbolis sokame i rezultatui (jne - jump not equal)
	mov	dx, offset klaidosPranesimas    ; isvedamojo teksto adresas
	mov ah, 09h                         ; spausdinimo funkcijos numeris
	int	21h			                    ; spausdiname pranesima
	jmp pabaiga	                        ; sokame i pabaiga, jei nieko nebuvo ivesta

ciklas:

	mov dl, [bx]              ; i dl registr i atminties adresu ds:bx keliama reiksme (1 baitas ikeliama) 
	cmp	dl, '0'		          ; lyginam einamaji simboli su '0'
	jb	neSkaicius		      ; jei einamasis simbolis maesnis u '0' tai einam i neSkaicius (jb - jump if below)
	cmp	dl, '9'		          ; lyginam dl su '9'
	ja	neSkaicius		      ; jei dl didesnis uz '9', tai einam i neSkaicius (ja - jump if above)
	cmp	dl, '0'               ; lyginam dl su '0'
	je nulis1                 ; jei dl lygus '0', tai einam i nulis1 (je - jump if equal) 
	cmp	dl, '1'               ; lyginam dl su '1'
	je vienas1                ; jei dl lygus '1', tai einam i vienas1 
	cmp	dl, '2'               ; lyginam dl su '2' 
	je du1                    ; jei dl lygus '2', tai einam i du1 
	cmp	dl, '3'               ; lyginam dl su '3'
	je trys1                  ; jei dl lygus '3', tai einam i trys1
	cmp	dl, '4'               ; lyginam dl su '4' 
	je keturi1                ; jei dl lygus '4', tai einam i keturi1 
	cmp	dl, '5'               ; lyginam dl su '5'
	je penki1                 ; jei dl lygus '5', tai einam i penki1 
	cmp	dl, '6'               ; lyginam dl su '6'
	je sesi1                  ; jei dl lygus '6', tai einam i sesi1  
	cmp	dl, '7'               ; lyginam dl su '7'
	je septyni1               ; jei dl lygus '7', tai einam i septyni1 
	cmp	dl, '8'               ; lyginam dl su '8'
	je astuoni1               ; jei dl lygus '8', tai einam i astuoni1 
	cmp	dl, '9'               ; lyginam dl su '9'
	je devyni1	              ; jei dl lygus '9', tai einam i devyni1
	
 
vieta:  
	inc	bx			      ; perstumiame adres vienu baitu  priek -  kit nuskaityt simbol (inc - increment)
	;dec	cl			      ; sumainame simboli, kuriuos reikia perirti, skaii (dec - decrement)
	;cmp	cl, 0			  ; lyginam cl su 0
	;jne	ciklas			  ; jei randam, kad likusiu simbuliu dar yra einam  cikla
	loop ciklas               ; ta pati padaro kaip ir 131 - 133 eilutes, ciklas
    
    jmp pabaiga	          ; jei jau nebera ko tikrinti is simboliu, sokame i pabaiga

neSkaicius:
	mov	ah, 02h          ; nurodomo naudojamos funckijos numeri (skirta isvesti vienam simboliui) 
	int	21h			     ; isvedame simboli i ekrana
	
	jmp vieta            ; po visko sokame i vieta
	
nulis1:
	mov	dx, offset nulis ; isvedamojo teksto adresas
	mov	ah, 09h          ; spausdinimo funkcijos numeris
	int	21h			     ; isvedame simboli
	jmp vieta

vienas1:
	mov	dx, offset vienas ; isvedamojo teksto adresas
	mov	ah, 09h           ; spausdinimo funkcijos numeris
	int	21h			      ; isvedame simboli
	jmp vieta
	
du1:
	mov	dx, offset du    ; isvedamojo teksto adresas
	mov	ah, 09h          ; spausdinimo funkcijos numeris
	int	21h			     ; isvedame simboli
	jmp vieta
	
trys1:
	mov	dx, offset trys  ; isvedamojo teksto adresas
	mov	ah, 09h          ; spausdinimo funkcijos numeris 
	int	21h			     ; isvedame simboli
	jmp vieta
	
keturi1:
	mov	dx, offset keturi ; isvedamojo teksto adresas
	mov	ah, 09h           ; spausdinimo funkcijos numeris
	int	21h			      ; isvedame simboli
	jmp vieta
	
penki1:
	mov	dx, offset penki ; isvedamojo teksto adresas
	mov	ah, 09h          ; spausdinimo funkcijos numeris
	int	21h			     ; isvedame simboli
	jmp vieta
	
sesi1:
	mov	dx, offset sesi  ; isvedamojo teksto adresas
	mov	ah, 09h          ; spausdinimo funkcijos numeris
	int	21h			     ; isvedame simboli
	jmp vieta
	
septyni1:
	mov	dx, offset septyni ; isvedamojo teksto adresas
	mov	ah, 09h            ; spausdinimo funkcijos numeris
	int	21h			       ; isvedame simboli
	jmp vieta
	
astuoni1:
	mov	dx, offset astuoni ; isvedamojo teksto adresas
	mov	ah, 09h            ; spausdinimo funkcijos numeris
	int	21h			       ; isvedame simboli
	jmp vieta
	
devyni1:
	mov	dx, offset devyni ; isvedamojo teksto adresas
	mov	ah, 09h           ; spausdinimo funkcijos numeris
	int	21h			      ; isvedame simboli
	jmp vieta	
	
pabaiga:
    mov	dx, offset enteris                  ; isvedamojo teksto adresas
	mov ah, 09h                             ; spausdinimo funckijos numeris
	int	21h	
 
    mov dx, offset pabaigosPranesimas 	    ; isvedamojo teksto adresas
    mov ah, 09h		      	                ; spausdinimo funckijos numeris
    int 21h			                        ; isveda pranesima

	mov	ah, 4Ch		; griztame i dos'a, reikalinga kiekvienos programos pabaigoj. Pabaigos funkcijos numeris
	mov	al, 0		; be klaidu, reikalinga kiekvienos programos pabaigoj
	int	21h			; dos'o interuptas, reikalinga kiekvienos programos pabaigoj	
        	
end pradzia         ; programos failo pabaiga
